<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_RentacarLocationListRequest StructType
 * @subpackage Structs
 */
class JP_RentacarLocationListRequest extends AbstractStructBase
{
    /**
     * The ZoneCode
     * Meta information extracted from the WSDL
     * - use: required
     * @var int
     */
    public $ZoneCode;
    /**
     * The Suppliers
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_Suppliers
     */
    public $Suppliers;
    /**
     * The ShowBasicInfo
     * @var bool
     */
    public $ShowBasicInfo;
    /**
     * Constructor method for JP_RentacarLocationListRequest
     * @uses JP_RentacarLocationListRequest::setZoneCode()
     * @uses JP_RentacarLocationListRequest::setSuppliers()
     * @uses JP_RentacarLocationListRequest::setShowBasicInfo()
     * @param int $zoneCode
     * @param \StructType\JP_Suppliers $suppliers
     * @param bool $showBasicInfo
     */
    public function __construct($zoneCode = null, \StructType\JP_Suppliers $suppliers = null, $showBasicInfo = null)
    {
        $this
            ->setZoneCode($zoneCode)
            ->setSuppliers($suppliers)
            ->setShowBasicInfo($showBasicInfo);
    }
    /**
     * Get ZoneCode value
     * @return int
     */
    public function getZoneCode()
    {
        return $this->ZoneCode;
    }
    /**
     * Set ZoneCode value
     * @param int $zoneCode
     * @return \StructType\JP_RentacarLocationListRequest
     */
    public function setZoneCode($zoneCode = null)
    {
        // validation for constraint: int
        if (!is_null($zoneCode) && !(is_int($zoneCode) || ctype_digit($zoneCode))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($zoneCode, true), gettype($zoneCode)), __LINE__);
        }
        $this->ZoneCode = $zoneCode;
        return $this;
    }
    /**
     * Get Suppliers value
     * @return \StructType\JP_Suppliers|null
     */
    public function getSuppliers()
    {
        return $this->Suppliers;
    }
    /**
     * Set Suppliers value
     * @param \StructType\JP_Suppliers $suppliers
     * @return \StructType\JP_RentacarLocationListRequest
     */
    public function setSuppliers(\StructType\JP_Suppliers $suppliers = null)
    {
        $this->Suppliers = $suppliers;
        return $this;
    }
    /**
     * Get ShowBasicInfo value
     * @return bool|null
     */
    public function getShowBasicInfo()
    {
        return $this->ShowBasicInfo;
    }
    /**
     * Set ShowBasicInfo value
     * @param bool $showBasicInfo
     * @return \StructType\JP_RentacarLocationListRequest
     */
    public function setShowBasicInfo($showBasicInfo = null)
    {
        // validation for constraint: boolean
        if (!is_null($showBasicInfo) && !is_bool($showBasicInfo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($showBasicInfo, true), gettype($showBasicInfo)), __LINE__);
        }
        $this->ShowBasicInfo = $showBasicInfo;
        return $this;
    }
}
